﻿using MindFusion.Diagramming;
using MindFusion.Drawing;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace PredShapes
{
	// Learn more about making custom code visible in the Xamarin.Forms previewer
	// by visiting https://aka.ms/xamarinforms-previewer
	[DesignTimeVisible(false)]
	public partial class MainPage : ContentPage
	{
		public MainPage()
		{
			InitializeComponent();

			Diagram diagram = diagramView.Diagram;

			diagram.SelectAfterCreate = false;

			// set colors
			diagram.BackBrush = new SolidBrush(Color.Azure);
			diagram.ShapeNodeStyle.Brush = new
				LinearGradientBrush(
				Color.FromRgba(255, 255, 255, 100),
				Color.FromRgba(0, 128, 192, 255), 45);
			diagram.DiagramStyle.ShadowBrush = new SolidBrush(Color.FromRgba(0, 0, 0, 20));
			diagram.DiagramStyle.NodeEffects.Add(new GlassEffect());
			diagram.DiagramStyle.FontFamily = "Tahoma";
			diagram.DiagramStyle.FontSize = 3;

			int i = 0;
			int hsize = 17;
			int vsize = 19;
			int perLine = 8;

			// enum all predefined shapes
			foreach (Shape shape in Shape.Shapes)
			{
				// skip arrowheads
				if (shape.Outline.Length == 0 ||
					shape == ArrowHeads.RevWithCirc ||
					shape == ArrowHeads.DoubleArrow)
					continue;

				// create a box of this shape
				ShapeNode box = diagram.Factory.CreateShapeNode(
					(i % perLine) * (hsize + 5) + 2,
					(i / perLine) * (vsize + 15) + 4,
					hsize, vsize, shape);

				box.Pen = new Pen(Color.Black, 0);

				var label = diagram.Factory.CreateShapeNode(
					(i % perLine) * (hsize + 5) + 2,
					(i / perLine) * (vsize + 15) + vsize + 4,
					hsize + 4, 8, Shapes.Rectangle);
				label.Text = shape.Id;
				label.Locked = true;
				label.Transparent = true;

				label.AttachToNode(box, AttachToNode.BottomRight);

				i = i + 1;
			}

			diagram.ResizeToFitItems(4, true);
			diagram.ScrollToggle.IsActive = true;
		}
	}
}
